//Ionescu Vlad
//Complexitate O(HMAX * Q * log N)
#include <iostream>
#include <fstream> 
#include <algorithm>
#include <queue>
#include <vector>
#include <cstdio>
#include <cstring>
using namespace std;
#define maxn 1000100

long long N, Q, A, B;
int V[maxn], viz[maxn], TT[maxn], mm[maxn];
vector<long long> G[maxn], sum[maxn];

void DetArbore(int nod) {
     int p, q;
     queue<int> Q;
     vector<int> X;
     viz[nod]=1;
     Q.push(nod);
     while(!Q.empty()) {
          p=Q.front(); Q.pop();
          for(vector<long long>::iterator it=G[p].begin(); it!=G[p].end(); it++) {
              if(!viz[(*it)]) {
                   viz[(*it)]=1;
                   X.push_back(*it);
                   Q.push((*it));
              }
          }
          G[p].clear();
          for(vector<int>::iterator it=X.begin(); it!=X.end(); it++) {
               TT[(*it)] = p;
               G[p].push_back(*it);
          }
          X.clear();
     }
}

int  cmp(int a, int b) {
     return V[a] < V[b];
}

long long solve(int A, int B) {
     if(A == 1) return B;

     //ajung in nodul A fix a B-a oara

     int p = V[A] - B + 1;
     int res = 0;

     //caut binar primul nod pentru care V[nod] >= p
     int ls = 0, ld = (int)G[ TT[A] ].size();
     int poz_nod = 0;

     while(ls <= ld) {
          int  mij = (ls + ld) >> 1;

          if(V[ G[ TT[A] ][mij] ] >= p) {
               poz_nod = mij;
               ld = mij - 1;

               res = sum[ TT[A] ][ (int)sum[ TT[A] ].size() - 1 - poz_nod];
          }
          else {
               ls = mij + 1;
          }
     }

     res = res - (int)p * ((int )G[ TT[A] ].size() - poz_nod);

     //verific cate elemente sunt mai mari decat V[A]
     res += mm[A];

     return solve(TT[A], res);
}

int main() {
     ifstream f1("arb.in"); 
	 ofstream f2("arb.out");
     int  i, j, p, q;
	 int sol; 
	 
     f1>>N>>Q;

	for(i=2; i<=N; i++) {
          f1>>p;

          G[p].push_back(i);
          G[i].push_back(p);
     }
	 
	for(i=1; i<=N; i++) {
          f1>>V[i];
     }

     //orientez arborele avand radacina in nodul 1
     DetArbore(1);
		

	 
     for(i=1; i<=N; i++) {
          //sortez lista de fii
          sort(G[i].begin(), G[i].end(), cmp);
     }
	
     for(i=1; i<=N; i++) {
          p = G[i].size();
          q = 0;
          long long  lala = 0;

          for(j=p-1; j>=0; j--) {
               q += V[ G[i][j] ];
               lala ++;
               mm[ G[i][j] ] = lala;
               sum[i].push_back(q);

          }
     }
	

 
     while(Q--) {
          f1>>A>>B;
          //sa ajung de B ori in nodul A

          if(A == 1) {
               f2<<B<<endl;

               continue;
          }
		
		  sol=solve(A,B);
          f2<<sol<<endl;;
     }
	f1.close(); f2.close();
	return 0;
}
