//Oprica Dragos Vasile
//Complexitate: O (N^2 * 2^N + N * K^2 * log K) - 100p
#include <algorithm>
#include <fstream>
#include <cassert>
#include <cstring>
using namespace std;

ifstream fin ("campanie.in");
ofstream fout ("campanie.out");

#define INF 1LL<<60
#define MAXK 1005
#define MAXN 18

struct city {

  int xAS,yAS,xAP,yAP,K;
  int distX[MAXK],H[MAXK];
  int pozY[MAXK][MAXK];
};

long long cntMin;
city V[MAXN+1];
int N;

long long Dst[MAXN+1][MAXN+1];
long long BstCycle[MAXN+1][(1<<MAXN)+1];


void read () {
  int i,j,k;

  fin>>N;
  assert (N>=2 && N<=18);

  for (i=1; i<=N; ++i) {

    fin>>V[i].xAS>>V[i].yAS>>V[i].xAP>>V[i].yAP>>V[i].K;
    assert (V[i].xAS>=-10000 && V[i].xAS<=10000);
    assert (V[i].yAS>=-10000 && V[i].yAS<=10000);
    assert (V[i].xAP>=-10000 && V[i].xAP<=10000);
    assert (V[i].yAP>=-10000 && V[i].yAP<=10000);
    assert (V[i].K>=1 && V[i].K<=1000);

    for (j=1; j<V[i].K; ++j) {

      fin>>V[i].distX[j];
      assert (V[i].distX[j]>=1 && V[i].distX[j]<=1000);
    }

    for (j=1; j<=V[i].K; ++j) {

      fin>>V[i].H[j];
      assert (V[i].H[j]>=1 && V[i].H[j]<=1000);

      for (k=1; k<=V[i].H[j]; ++k) {

        fin>>V[i].pozY[j][k];
        assert (V[i].pozY[j][k]>=-10000 && V[i].pozY[j][k]<=10000);
      }
    }
  }
}

inline long long dist (const city &P,const city &S) {

  return 1LL*(P.xAP-S.xAS)*(P.xAP-S.xAS)+1LL*(P.yAP-S.yAS)*(P.yAP-S.yAS);
}

void solveCycle () {

  int state,i,j;

  for (i=1; i<=N; ++i)
    for (j=1; j<=N; ++j)
      if (i!=j)
        Dst[i][j]=dist (V[i],V[j]);

  for (i=1; i<=N; ++i)
      for (state=0; state<(1<<N); ++state)
        BstCycle[i][state]=INF;
  BstCycle[1][1]=0;

  for (state=0; state<(1<<N); ++state)
    for (i=1; i<=N; ++i)
      if (state&(1<<(i-1)))
        for (j=1; j<=N; ++j)
          if (state&(1<<(j-1)))
            BstCycle[i][state]=min (BstCycle[i][state],BstCycle[j][state^(1<<(i-1))]+Dst[j][i]);

  cntMin=INF;
  for (i=1; i<=N; ++i)
    cntMin=min (cntMin,BstCycle[i][(1<<N)-1]+Dst[i][1]);
}

inline long long dist (int x,int y1,int y2) {

  return 1LL*x*x+1LL*(y1-y2)*(y1-y2);
}

int solveCity (city &A) {
  long long cntCur,minCur;
  int i,j,k;

  cntCur=0;
  sort (A.pozY[1]+1,A.pozY[1]+A.H[1]+1);
  for (i=1; i<A.K; ++i) {
    sort (A.pozY[i+1]+1,A.pozY[i+1]+A.H[i+1]+1);

    k=1; minCur=INF;
    for (j=1; j<=A.H[i]; ++j) {

      while (k<=A.H[i+1] && A.pozY[i][j]>A.pozY[i+1][k])
        ++k;

      if (A.pozY[i][j]==A.pozY[i+1][k]) {

        minCur=dist (A.distX[i],A.pozY[i][j],A.pozY[i+1][k]);
        break ;
      }

      if (k>=2)
        minCur=min (minCur,dist (A.distX[i],A.pozY[i][j],A.pozY[i+1][k-1]));

      if (k<=A.H[i+1])
        minCur=min (minCur,dist (A.distX[i],A.pozY[i][j],A.pozY[i+1][k]));
    }

    cntCur+=minCur;
  }

  return cntCur;
}

void solve () {
  int i;

  solveCycle ();
  for (i=1; i<=N; ++i)
    cntMin+=solveCity (V[i]);

  fout<<cntMin;
}

int main () {

  read ();
  solve ();

  return 0;
}
