/* Tiberiu Savin */

#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 40005

int N, M, K;
int left[NMAX], right[NMAX];
int super_left[NMAX], super_right[NMAX];

int go_deep(int nod, int lst) {
    int lst2;
    if (left[nod] == lst) {
        lst2 = lst;
        lst = nod;
        nod = super_right[nod];
    } else {
        lst2 = lst;
        lst = nod;
        nod = super_left[nod];
    }
    int super_jump = 1;
    if (nod == 0) {
        super_jump = 0;
        nod = lst;
        lst = lst2;
    }

    while (super_jump) {
        if ((super_left[nod] == lst && super_right[nod] == 0) ||
            (super_right[nod] == lst && super_left[nod] == 0)) {
            break;
        }

        if (super_left[nod] == lst) {
            lst = nod;
            nod = super_right[nod];
        } else {
            lst = nod;
            nod = super_left[nod];
        }

    }

    if (super_jump) {
        if (super_left[nod] == lst) {
            lst = nod;
            nod = right[nod];
        } else {
            lst = nod;
            nod = left[nod];
        }
    }

    if (!nod) {
        return lst;
    }

    while (1) {
        if ((left[nod] == lst && right[nod] == 0) ||
            (right[nod] == lst && left[nod] == 0)) {
            return nod;
        }

        if (left[nod] == lst) {
            lst = nod;
            nod = right[nod];
        } else {
            lst = nod;
            nod = left[nod];
        } 
    }
}

bool check_add(int x, int y) {
    int omolog;
    if (left[x] == 0 && right[x] == 0) {
        omolog = x;
    } if (left[x] == 0) {
        omolog = go_deep(right[x], x);
    } else {
        omolog = go_deep(left[x], x);
    }

    if (omolog == y) {
        return false;
    }

    if (left[x] && right[x]) {
        return false;
    }

    if (left[y] && right[y]) {
        return false;
    }

    return true;
}

void add_edge(int x, int y) {
    if (!check_add(x, y)) {
        printf("0\n");
        return;
    }
    printf("1\n");

    if (left[x] == 0) {
        left[x] = y;
    } else {
        right[x] = y;
    }

    if (left[y] == 0) {
        left[y] = x;
    } else {
        right[y] = x;
    }

    // Maintain super neighbours
    // try to go K steps in one direction, and then go back
    int lst = x;
    int nod = y;
    int dist = K - 1;
    for (int i = 1; i <= K - 1; i++) {
        if (left[nod] == lst) {
            lst = nod;
            nod = right[nod];
        } else {
            lst = nod;
            nod = left[nod];
        }

        if (nod == 0) {
            nod = lst;
            if (left[nod]) {
                lst = left[nod];
            } else {
                lst = right[nod];
            }

            dist = i - 1;
            break;
        }
    }

    int nod1 = nod;
    int lst1 = lst;

    nod = x;
    lst = y;

    for (int i = 1; i <= K - dist - 1; i++) {
        if (left[nod] == lst) {
            lst = nod;
            nod = right[nod];
        } else {
            lst = nod;
            nod = left[nod];
        }

        if (nod == 0) {
            // no super-neighbours to maintain
            return;
        }
    }

    int nod2 = nod;
    int lst2 = lst;

    // Reverse direction

    if (left[nod1] == lst1) {
        lst1 = right[nod1];
    } else {
        lst1 = left[nod1];
    }

    while (nod1 != x) {
        if (left[nod1] == lst1) {
            super_right[nod1] = nod2;
        } else {
            super_left[nod1] = nod2;
        }

        if (left[nod2] == lst2) {
            super_left[nod2] = nod1;
        } else {
            super_right[nod2] = nod1;
        }

        if (left[nod1] == lst1) {
            lst1 = nod1;
            nod1 = right[nod1];
        } else {
            lst1 = nod1;
            nod1 = left[nod1];
        }

        if (left[nod2] == lst2) {
            lst2 = nod2;
            nod2 = right[nod2];
        } else {
            lst2 = nod2;
            nod2 = left[nod2];
        }

        // we could reach the end
        if (nod2 == 0) {
            break; 
        }
    }
}

void erase_super_neighbours(int nod) {
    int lst = 0;
    for (int i = 1; i <= K; i++) {
        if (left[nod] == lst) {
            super_left[nod] = 0;
        } else {
            super_right[nod] = 0;
        }

        if (left[nod] == lst) {
            lst = nod;
            nod = right[nod];
        } else {
            lst = nod;
            nod = left[nod];
        }

        if (nod == 0) {
            break;
        }
    }
}

void erase_edge(int x, int y) {
    bool success = 0;
    if (left[x] == y) {
        left[x] = 0;
        success = 1; 
    } else if (right[x] == y) {
        right[x] = 0;
        success = 1;
    }

    if (left[y] == x) {
        left[y] = 0;
    } else if (right[y] == x) {
        right[y] = 0;
    }

    // Erase super-neighbours
    if (success) {
        erase_super_neighbours(x);
        erase_super_neighbours(y);
    }
    printf("%d\n", success);
}

int go(int dist, int nod, int lst) {
    int lst2 = 0;
    //printf("right=%d left=%d init=%d ", right[830], left[830], nod);
    

    if (nod == 0) {
        return 0;
    }

    if (left[nod] == lst) {
        lst2 = lst;
        lst = nod;
        nod = super_right[nod];
    } else {
        lst2 = lst;
        lst = nod;
        nod = super_left[nod];
    }

    int step, super_jump = 1;
    if (nod != 0) {
        step = K + 1;
    } 

    if (step >= dist || nod == 0) {
        nod = lst;
        lst = lst2;
        step = 1;
        super_jump = 0;
    }

    for (int i = step; i < dist && super_jump; i += K) {      
        if (super_left[nod] == lst) {
            lst2 = lst;
            lst = nod;
            nod = super_right[nod];
        } else {
            lst2 = lst;
            lst = nod;
            nod = super_left[nod];
        }

        if (nod) {
            step = step + K;
            if (step >= dist) {
                step -= K;
                nod = lst;
                lst = lst2;
            }
        } else {
            nod = lst;
            lst = lst2;
            break;
        }
    }

    int first = 1;
    // printf("step=%d nod=%d ", step, nod);
    for (int i = step; i < dist; i++) {
        int left_nod;
        if (first && super_jump) {
            left_nod = super_left[nod];
        } else {
            left_nod = left[nod];
        }
        first = 0;

        if (left_nod == lst) {
            lst = nod;
            nod = right[nod];
        } else {
            lst = nod;
            nod = left[nod];
        }

        if (nod == 0) {
            return 0;
        }
    }

    return nod;
}

void print_ans(int nod1, int nod2) {
    vector<int> ret;
    if (nod1) {
        ret.push_back(nod1);
    }

    if (nod2 && nod1 != nod2) {
        ret.push_back(nod2);
    }

    printf("%d ", (int) ret.size());

    sort(ret.begin(), ret.end());
    for (int i = 0; i < (int) ret.size(); i++) {
        printf("%d ", ret[i]);
    }

    printf("\n");
}

void query_dist(int x, int d) {
    if (d == 0) {
        printf("1 %d\n", x);
        return;
    }

    int nod1 = go(d, left[x], x);
    int nod2 = go(d, right[x], x);
    print_ans(nod1, nod2);
}

void query_road(int x) {
    int nod1, nod2;
    if (left[x] == 0) {
        nod1 = x;
    } else {
        nod1 = go_deep(left[x], x);
    }
    
    if (right[x] == 0){
        nod2 = x;
    } else {
        nod2 = go_deep(right[x], x); 
    }

    print_ans(nod1, nod2);    
}

int main() {
    freopen("drumuri.in", "r", stdin);
    freopen("drumuri.out", "w", stdout);

    scanf("%d %d ", &N, &M);
    K = 100;

    for (int i = 1; i <= M; i++) {
        int cod;
        scanf("%d ", &cod);
        if (cod == 1) {
            int x, y;
            scanf("%d %d ", &x, &y);
            add_edge(x, y);
        } else if (cod == 2) {
            int x, y;
            scanf("%d %d ", &x, &y);
            erase_edge(x, y);
        } else if (cod == 3) {
            int x, d;
            scanf("%d %d ", &x, &d);
            query_dist(x, d);
        } else {
            int x;
            scanf("%d ", &x);
            query_road(x);
        }
    }
}
