/* Cosmin Tutunaru */

#include<cstdio>
#include<vector>
#include<algorithm>
#define infile "drumuri.in"
#define outfile "drumuri.out"
#define nMax 40013

using namespace std;

int v[nMax][2];
int n, m;

int findHead(int x, int y, int d = 1<<30) {
  int crt = 0;
  while((v[x][0] && v[x][0] != y) || (v[x][1] && v[x][1] != y)) {
    if(crt == d) break;
    int z = x;
    ++crt;

    if(v[x][0] && v[x][0] != y) x = v[x][0];
    else x = v[x][1];
    y = z;

  }

  if(d == 1<<30) return x;
  if(crt == d) return x;
  return 0;
}

vector <int> findHeads(int x) {
  int a = findHead(v[x][0], x);
  int b = findHead(v[x][1], x);
  vector <int> v;

  if(!a) a = x;
  if(!b) b = x;

  v.push_back(a);
  if(a != b) v.push_back(b);

  sort(v.begin(), v.end());
  return v;
}

vector <int> findAtDist(int x, int d) {

  if(d == 0) return vector<int>(1, x);

  int a = findHead(v[x][0], x, d-1);
  int b = findHead(v[x][1], x, d-1);
  vector <int> v;

  if(a) v.push_back(a);
  if(b) v.push_back(b);

  sort(v.begin(), v.end());
  return v;
}

bool add(int x, int y) {

  if(v[x][0] && v[x][1]) return false;
  if(v[y][0] && v[y][1]) return false;

  vector <int> a = findHeads(x);
  vector <int> b = findHeads(y);

  if(a == b && (a.size() || b.size())) return false;
  !v[x][0] ? v[x][0] = y : v[x][1] = y;
  !v[y][0] ? v[y][0] = x : v[y][1] = x;

  return true;
}

bool rmv(int x, int y) {

  if(v[x][0] == y) {
    v[x][0] = 0;
    v[y][0] == x ? v[y][0] = 0 : v[y][1] = 0;
    return true;
  }

  if(v[x][1] == y) {
    v[x][1] = 0;
    v[y][0] == x ? v[y][0] = 0 : v[y][1] = 0;
    return true;
  }

  return false;
}

void write(vector <int> v) {
  printf("%d", v.size());
  for(unsigned i = 0; i < v.size(); ++i) {
    printf(" %d", v[i]);
  }
  printf("\n");
}

void solve() {

  scanf("%d %d\n", &n, &m);

  while(m--) {

    int type, x, y, d;
    scanf("%d", &type);

    switch(type) {
      case 1:
        scanf("%d %d", &x, &y);
        printf("%d\n", add(x, y));
        break;
      case 2:
        scanf("%d %d", &x, &y);
        printf("%d\n", rmv(x, y));
        break;
      case 3:
        scanf("%d %d", &x, &d);
        write(findAtDist(x, d));
        break;
      case 4:
        scanf("%d", &x);
        write(findHeads(x));
        break;
    }
  }

}

int main() {
  freopen(infile, "r", stdin);
  freopen(outfile, "w", stdout);

  solve();

  fclose(stdin);
  fclose(stdout);
  return 0;
}
