/* Mugurel Andreica */
#include <stdio.h>
#include <time.h>

#define NMAX 40001
#define K 200

#define USE_FAST_SOLUTION 0

int neigh[NMAX][2], kneigh[NMAX][2], p[NMAX];
int ki[K+1], kj[K+1], diri[K+1], dirj[K+1];
int t, i, j, d, dd, N, M, ci, cj;

void find_opposite_endpoint(int i, int j, int dmax, int& endpoint, int& distance) {
    endpoint = i;
    distance = 0;
    int dir;

    if (neigh[i][0] == j)
        dir = 1;
    else
        dir = 0;

    endpoint = i;

    while (1) {
        if (distance + K > dmax)
            break;
        if (kneigh[endpoint][dir] == 0)
            break;
        j = endpoint;
		endpoint = kneigh[endpoint][dir];
        distance += K;
        if (kneigh[endpoint][dir] == j)
            dir = 1 - dir;
    }
	
    while (1) {
        if (distance == dmax)
            break;
        if (neigh[endpoint][dir] == 0)
            break;
		j = endpoint;
		endpoint = neigh[endpoint][dir];
        distance++;
        if (neigh[endpoint][dir] == j)
            dir = 1 - dir;
    }
}

void update_kneighs(int i, int j, int op) {
	int u, v;

	ci = 0; u = i; v = j;
    while (u > 0 && ci < K) {
		ki[ci] = u;
		if (neigh[u][0] == v) {
			v = u;
			u = neigh[u][1];
			diri[ci] = 0;
		} else {
			v = u;
			u = neigh[u][0];
			diri[ci] = 1;
		}
		ci++;
	}

	cj = 0; u = j; v = i;
	while (u > 0 && cj < K) {
		kj[cj] = u;
		if (neigh[u][0] == v) {
			v = u;
			u = neigh[u][1];
			dirj[cj] = 0;
		} else {
			v = u;
			u = neigh[u][0];
            dirj[cj] = 1;
		}
		cj++;
	}

	for (u = 0; u < ci; u++) {
		if (op == 1) {
			v = K - u - 1;
			if (cj > v) {
				kneigh[ki[u]][diri[u]] = kj[v];
			}
		} else
			kneigh[ki[u]][diri[u]] = 0;
	}

	for (u = 0; u < cj; u++) {
		if (op == 1) {
			v = K - u - 1;
			if (ci > v) {
				kneigh[kj[u]][dirj[u]] = ki[v];
			}
		} else
			kneigh[kj[u]][dirj[u]] = 0;
	}
}

void print_nodes(int u, int v) {
	if (u == v)
		u = 0;
	if (u > 0 && v > 0) {
        printf("2 ");
		if (u < v)
			printf("%d %d\n", u, v);
		else
			printf("%d %d\n", v, u);
	} else if (u == 0 && v > 0) {
		printf("1 %d\n", v);
	} else if (u > 0 && v == 0) {
		printf("1 %d\n", u);
	} else {
		printf("0\n");
	}
}

int main() {
	int u, v, tstart = clock();

    freopen("drumuri.in", "r", stdin);
    freopen("drumuri.out", "w", stdout);

    scanf("%d %d", &N, &M);

    for (i = 1; i <= N; i++)
        p[i] = i;

    while (M--) {
        scanf("%d %d", &t, &i);
        if (t == 1) {
            scanf("%d", &j);

            // Add a new edge i-j.
            if (p[i] != j && p[i] > 0 && p[j] > 0 && i != j) {
                // Connect the nodes i and j.
                if (neigh[i][0] == 0)
                    neigh[i][0] = j;
                else
                    neigh[i][1] = j;

                if (neigh[j][0] == 0)
                    neigh[j][0] = i;
                else
                    neigh[j][1] = i;

				// Update k-neighbors.
                if (USE_FAST_SOLUTION)
					update_kneighs(i, j, 1);

                // Adjust the endpoint pairs.
                if (p[i] == i) {
                    ci = 0;
                } else {
                    ci = 1;
                }

                if (p[j] == j) {
                    cj = 0;
                } else {
                    cj = 1;
                }

                u = p[i]; v = p[j];
                p[u] = v;
                p[v] = u;

                if (ci)
                    p[i] = 0;

                if (cj)
                    p[j] = 0;

                printf("1\n");
            } else {
                printf("0\n");
            }
        } else if (t == 2) {
            scanf("%d", &j);

            // Remove an old edge i-j.
            if (neigh[i][0] == j || neigh[i][1] == j) {
                find_opposite_endpoint(i, j, N, u, d);
                v = p[u];

				// Adjust k-neighbors.
                if (USE_FAST_SOLUTION)
					update_kneighs(i, j, 2);

                // Clear the neighbors i and j.
                if (neigh[i][0] == j)
                    neigh[i][0] = 0;
                else
                    neigh[i][1] = 0;

                if (neigh[j][0] == i)
                    neigh[j][0] = 0;
                else
                    neigh[j][1] = 0;

                // Adjust the endpoint pairs.
                p[i] = u;
                p[u] = i;
                p[j] = v;
                p[v] = j;

                printf("1\n");
            } else {
                printf("0\n");
            }
        } else if (t == 3) {
            scanf("%d", &d);

            // Compute the neighbors located at distance d from the node i (on the existing paths).
			find_opposite_endpoint(i, neigh[i][0], d, u, dd);
            if (dd != d)
                u = 0;

			find_opposite_endpoint(i, neigh[i][1], d, v, dd);
            if (dd != d)
                v = 0;

			print_nodes(u, v);
        } else if (t == 4) {
            // Compute the distances from the two endpoints of the path to which node i belongs.
			find_opposite_endpoint(i, neigh[i][0], N, u, dd);
			find_opposite_endpoint(i, neigh[i][1], N, v, dd);
			print_nodes(u, v);
        }
    }

	fprintf(stderr, "Duration=%.3lf sec\n", (double) (clock() - tstart) / CLOCKS_PER_SEC);	
    return 0;
}
