/* Andrei Parvu
   O(N * logK) */

#include <cstdio>
#include <queue>
#include <cassert>

using namespace std;

const int NMAX = 200000, KMAX = 1000000000;

#define x first
#define y second
#define ii pair<long long, int>

int N, K;
ii dreapta[NMAX + 5];
long long sumFound, totalFound, found;

void bs() {
  long long li = 1, ls = 1LL << 32, x;

  while (li <= ls) {
    x = (li + ls) / 2;

    long long total = 0, suma = 0;
    for (int i = 1; i <= N; i ++) {
      long long cate = 0;

      if (x >= dreapta[i].y) {
        cate = (x - dreapta[i].y) / dreapta[i].x + 1;
      }

      total += cate;

      suma += cate * dreapta[i].y + (cate - 1) * cate / 2 * dreapta[i].x;
    }

    if (total >= K) {
      found = x;
      sumFound = suma;
      totalFound = total;
      ls = x - 1;
    } else {
      li = x + 1;
    }
  }
}


int main() {
  freopen("tarabe.in", "rt", stdin);
  freopen("tarabe.out", "wt", stdout);

  assert(scanf("%d %d", &N, &K) == 2);
  assert(1 <= N && N <= NMAX && 1 <= K && K <= KMAX);

  for (int i = 1; i <= N; i ++) {
    assert(scanf("%lld %d", &dreapta[i].x, &dreapta[i].y) == 2); //x * timp + y
    assert(1 <= dreapta[i].x && dreapta[i].x <= 1000 && 1 <= dreapta[i].y && dreapta[i].y <= 1000);
  }

  bs();

  sumFound -= (totalFound - K) * found;

  printf("%lld\n", sumFound);

  return 0;
}

